
#include <stdlib.h>
#include <stdio.h>

/* scambia il contenuto di due variabili */
int scambia(int *a, int *b) {
  int tmp = *a;
  *a = *b;
  *b = tmp;
} 

/* 
  sx e dx sono le posizioni del primo e dell'ultimo elemento dell'array mentre 
  px è la posizione dell'elemento perno. 
  La funzione deve restituisce la posizione del perno dopo che gli elementi sono 
  stati partizionati.
*/

/* Versione degli appunti */
int distribuzione(int a[], int sx, int px, int dx) {

  int i, j; 
  if ( px != sx ) scambia(&a[sx], &a[px]);
  px = sx;

  for( i = sx, j = sx+1; j <= dx; j++ ) 
      if( a[j] <= a[px] ) scambia( &a[++i], &a[j] );
  
  if( px != i) scambia( &a[px], &a[i] );
  return i;
 
}

/* Versione del libro di testo */
int distribuzione1(int a[], int sx, int px, int dx) {

  int i = sx, j = dx -1;
  
  if ( px != dx ) scambia(&a[px], &a[dx]);
  while ( i <= j ) {
    while ( ( i <= j ) && ( a[i] <= a[dx] ) ) // continua finche non trova il primo elemento >= a[dx] (o tale elemento non esiste)
	i++;
    while ( ( i <= j ) && ( a[j] >= a[dx] ) ) // continua finche non trova il primo elemento <= a[dx] (o tale elemento non esiste)
	j--;
    if ( i < j ) scambia( &a[i], &a[j] );  
  }

  if( i != dx ) scambia( &a[i], &a[dx] );
  
  return i; // restituisce la posizione del perno 

}

void quick_sort( int a[], int sx, int dx ) {
  
  int perno, pivot;
  if( sx < dx ) {
    pivot = sx + rand()%(dx-sx+1);
    perno = distribuzione(a, sx, pivot, dx); // separa gli elementi minori di a[pivot] 
					     // da quelli maggiori o uguali 
    /* Ordina ricorsivamente le due metà */
    quick_sort(a, sx, perno-1);
    quick_sort(a, perno+1, dx);
    
  }

}

/* Lettura di un array di interi da input. 
Il primo elemento è la lunghezza dell'array */
int legge(int **a, int *len) {

  int i;
  scanf("%d", len);
  if(*len <= 0) return 1;

  *a = (int *) malloc(*len * sizeof(int));
  if(*a == NULL) return 1;

  for( i = 0; i < *len; i++ ) 
	  scanf("%d", (*a)+i);
  
  return 0;

}

int main() {
  
  int i, n, *A;

  if( legge(&A, &n)) return 1;
  
  srand(time(NULL));
  quick_sort(A, 0, n-1);
  
  /* Stampa l'array ordinato */
  for( i = 0; i < n; i++ ) 
    printf("%d\n", A[i]);

}